﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CppCLI;

namespace CSharpTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Class1 c1 = new Class1();
            MessageBox.Show(c1.ToString());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            CppClass cpp = new CppClass();
            int c = cpp.add(1, 2);
            Console.WriteLine(c);

            int[] ar = new int[] { 1, 2, 3, 4, 5 };
            int sum = cpp.add(ar);
            Console.WriteLine(sum);

            ClassA ca = new ClassA();
            ca.set_data(3);
            ClassB cb = new ClassB();
            cb.set_data(4);
            ClassC cc = cpp.add(ca, cb);
            Console.WriteLine(cc.get_data());

            ca.set_data(cc.get_data());
            cpp.add(ca, cb, cc);
            Console.WriteLine(cc.get_data());

            cpp.print("Hello from c#.\n");

            StringBuilder sb = new StringBuilder();
            cpp.report(sb);
            Console.WriteLine(sb);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int[] ar = new int[] { 1, 2, 3, 4, 5 };
            CppClass cpp = new CppClass();
            int n = ar.Length;
            int sum;
            unsafe
            {
                fixed (int* ar_p = ar)
                {
                    sum = cpp.add(ar_p, n);
                }
            }
            Console.WriteLine(sum);

            int c;
            unsafe
            {
                cpp.add(3, 4, &c);
            }
            Console.WriteLine(c);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            CppClass cpp = new CppClass();
            int c;
            cpp.add(3, 4, out c);
            Console.WriteLine(c);
        }
    }
}
