#include "..\NativeCpp\cppclass.h"

#pragma once

#include <iostream>
#include <sstream>

using namespace std;

using namespace System;
using namespace System::Text;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Data;
using namespace System::Runtime::InteropServices;

namespace CppCLI 
{
	public ref class CppClass
	{
	private:
		::CppClass * _native;

	public:
		CppClass(::CppClass * native)
		{
			_native= native;
		}

		::CppClass* native()
		{
			return _native;
		}

		CppClass ()
		{ 
			_native = new ::CppClass();
		}

		~CppClass ()
		{ 	
			delete _native; 	
		}

		int ok ()  
		{
			return _native -> ok();
		}

		int add(int a, int b)
		{
			return _native->add(a, b);
		}

		int add(int* a, int n)
		{
			return _native->add(a, n);
		}

		int add(array<int>^ a)
		{
			pin_ptr<int> p_a = &a[0];
			int n = a->Length;
			return _native->add(p_a, n);
		}

		void add(int a, int b, int &c)
		{
			_native->add(a, b, c);
		}
		
		void add(int a, int b, [Out] int% c)
		{
			pin_ptr<int> p_c = &c;
			_native->add(a, b, *p_c);
		}

		ClassC^ add(ClassA^ a, ClassB^ b)
		{
			ClassC^ c = gcnew ClassC();
			c->set_data(_native->add(a->get_data(), b->get_data()));
			return c;
		}

		int add(ClassA^ a, ClassB^ b, ClassC^ c)
		{
			c->set_data(_native->add(a->get_data(), b->get_data()));
			return c->get_data();
		}

		void print(String^ s)
		{
			IntPtr s_pointer = Marshal::StringToHGlobalAnsi(s);
			char *s_native = static_cast<char*>(s_pointer.ToPointer());
			_native -> print(s_native);
			if(s_pointer != IntPtr::Zero)
			{
				Marshal::FreeHGlobal(s_pointer);
			}
		}

		int report(StringBuilder^ os)
		{
			ostringstream oss (ostringstream::out);
			int result = _native->report(oss);
			os->Append(gcnew String(oss.str().c_str()));			
			return result;
		}
	};
}